Index: GTP/trunk/App/Demos/Illum/Ogre/ReadMe.txt
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/ReadMe.txt	(revision 1478)
+++ GTP/trunk/App/Demos/Illum/Ogre/ReadMe.txt	(revision 1478)
@@ -0,0 +1,76 @@
+The OGRE integrated demos of different illumination module techniques can be found in this folder.
+
+Run
+-----
+The executables(Debug and Release) can be found in the \bin directory. The media files like textures, models, shaders etc.
+used by the demos can be found in the \Media directory.
+You don't need to compile the demos if you would only like to test the programs, 
+prebuilt executables are located in the bin/Release or Debug directory.
+
+Three demos are ready to run:
+	- GameToolsRaytraceDemo.exe : This demo demonstrates raytrace like effects such as reflections and refractions (using depth impostors)
+					and caustics. It also uses glow.
+	- GameToolsParticleDemo.exe : This demo demonstrates spherical billboards, a particle rendering technique that treates particles as spheres
+					(while still rendering them as billboards) and uses scene depth information to avoid billboard clipping artifacts.
+	- HPSDemo.exe : This Demo demonstrates hierarchical particle systems, which is a particle system made of particle system.
+			It first simulates a little particle system, stores its image to a texture and this image will be used as texture of one particle in the bigger particle system.
+			This way more particles can be simulated, and the "cheating" is usually not visible (as most of the natural phenomena shows self similarity).
+			The method also eliminates billboard clipping artifacts with a calculation similar to spherical billboards.
+			The demo also shows that this animated particle system can be shaded according to dynamic lighting conditions.
+	
+	(You can also find two more executables in this directory, but these demos are under development.)
+
+Usage
+-----
+
+The control is the same for all demos:
+
+W - move camera forward
+S - move camera back
+A - slide camera left
+D - slide camera right
+mouse - rotate camera
+F - show/hide FPS data
+R - toggle wireframe on/off
+
+
+Build
+-----
+
+These demos use OGRE 1.2 with changes can be found in the svn (www.gametools.org/repos/gametools/OGRE/trunk/ogre_changes/Ogre1.2).
+These OGRE changes should be copied to your OGRE 1.2 directory and OGRE should be rebuilt. It's important to set 
+the prepocessor definition : GAMETOOLS_ILLUMINATION_MODULE for these two projects: OgreMain, Direct3D9RenderSystem
+
+The demos also use a library called IllumModule and it's OGRE version OgreIllumModule.
+These libraries can be found in the svn : www.gametools.org/repos/gametools/GTP/trunk/Lib/Illum/IllumModule
+There is also a prepared solution file that containes these library projects and all the demo projects in folder:
+	www.gametools.org/repos/gametools/GTP/trunk/Lib/Illum/shared/scripts
+The source code of the demos are located in:
+	www.gametools.org/repos/gametools/GTP/trunk/App/Demos/Illum/Ogre/src
+So the following directory structure should be downloaded to successfully compile the demos and libraries:
+
+        -|
+         |--App
+         |   |
+         |   |--Demos
+         |       |
+         |       |--Illum
+         |            |
+         |            |--Ogre
+         |                |
+         |                |--bin...
+         |                |--Media...
+         |                |--src...
+         |
+         |
+         |--Lib
+             |
+             |--Illum
+                  |
+                  |--IllumModule...
+                  |--shared...
+
+An environment variable named OGRE_PATH should also be set to your OGRE root directory.
+If you made the steps above the build of the libraries and demos should succeed without errors.
+The demo executables will be copied to App/Demos/Illum/Ogre/bin/Debug or Release automatically.
+( Don't forget you should also copy the dll's from your Ogre directory (OGRE_PATH/Samples/Common/bin/Debug or Release) to these directory after building OGRE.)