Index: GTP/trunk/Lib/Vis/GtpVisibility.sln
===================================================================
--- GTP/trunk/Lib/Vis/GtpVisibility.sln	(revision 1489)
+++ GTP/trunk/Lib/Vis/GtpVisibility.sln	(revision 1492)
@@ -39,12 +39,4 @@
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436} = {80DECC17-BDDD-4412-8CF8-F7C1C17A7436}
 		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "gui", "Preprocessing\gui\gui.vcproj", "{8E28F667-63A7-4F41-81D0-233B971BF247}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "fractal", "Preprocessing\fractal\fractal.vcproj", "{00ED6D39-0F68-405F-AE02-B8886BACA7E2}"
-	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
@@ -393,84 +385,4 @@
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Universal Unicode Release.ActiveCfg = Release|Win32
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Universal Unicode Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Debug Static.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Debug Static.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Unicode Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Unicode Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Unicode Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Unicode Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Unicode Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Unicode Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Unicode Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.DLL Universal Unicode Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.mlrt.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.mlrt.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Release Internal.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Release Internal.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Release Static.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Release Static.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Unicode Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Unicode Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Unicode Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Unicode Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Release.Build.0 = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Unicode Debug.ActiveCfg = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Unicode Debug.Build.0 = Debug|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Unicode Release.ActiveCfg = Release|Win32
-		{8E28F667-63A7-4F41-81D0-233B971BF247}.Universal Unicode Release.Build.0 = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Debug.ActiveCfg = Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Debug.Build.0 = Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Debug Static.ActiveCfg = Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Debug Static.Build.0 = Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Debug.ActiveCfg = DLL Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Debug.Build.0 = DLL Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Release.ActiveCfg = DLL Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Release.Build.0 = DLL Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Unicode Debug.ActiveCfg = DLL Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Unicode Debug.Build.0 = DLL Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Unicode Release.ActiveCfg = DLL Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Unicode Release.Build.0 = DLL Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Debug.ActiveCfg = DLL Universal Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Debug.Build.0 = DLL Universal Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Release.ActiveCfg = DLL Universal Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Release.Build.0 = DLL Universal Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Unicode Debug.ActiveCfg = DLL Universal Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Unicode Debug.Build.0 = DLL Universal Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Unicode Release.ActiveCfg = DLL Universal Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.DLL Universal Unicode Release.Build.0 = DLL Universal Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.mlrt.ActiveCfg = DLL Universal Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.mlrt.Build.0 = DLL Universal Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Release.ActiveCfg = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Release.Build.0 = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Release Internal.ActiveCfg = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Release Internal.Build.0 = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Release Static.ActiveCfg = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Release Static.Build.0 = Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Unicode Debug.ActiveCfg = Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Unicode Debug.Build.0 = Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Unicode Release.ActiveCfg = Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Unicode Release.Build.0 = Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Debug.ActiveCfg = Universal Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Debug.Build.0 = Universal Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Release.ActiveCfg = Universal Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Release.Build.0 = Universal Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Unicode Debug.ActiveCfg = Universal Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Unicode Debug.Build.0 = Universal Unicode Debug|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Unicode Release.ActiveCfg = Universal Unicode Release|Win32
-		{00ED6D39-0F68-405F-AE02-B8886BACA7E2}.Universal Unicode Release.Build.0 = Universal Unicode Release|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution