Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_news.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_news.html	(revision 1477)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_news.html	(revision 1515)
@@ -10,11 +10,11 @@
 <LINK REL=STYLESHEET TYPE="text/css" HREF="../html/site.css">
 <STYLE>
-.News { font-family: Arial,Helvetica,Geneva,Sans-serif; background-color: rgb(204,204,204); border: 1pt solid rgb(0,0,0); padding: 2pt;}
+.News { font-family: Arial,Helvetica,Geneva,Sans-serif; background-color: rgb(255,255,255); border: 1pt dashed rgb(0,0,0); padding: 10pt;}
 </STYLE>
 </HEAD>
-<BODY NOF="(MB=(DefaultMasterBorder, 121, 61, 171, 0), L=(NewsLayout, 1108, 1300))" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
+<BODY NOF="(MB=(DefaultMasterBorder, 121, 127, 171, 0), L=(NewsLayout, 1108, 1504))" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
     <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
-            <TD WIDTH=15 HEIGHT=29><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=15 HEIGHT=1 BORDER=0 ALT=""></TD>
+            <TD WIDTH=13 HEIGHT=4><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=13 HEIGHT=1 BORDER=0 ALT=""></TD>
             <TD></TD>
         </TR>
@@ -22,32 +22,124 @@
             <TD></TD>
             <TD WIDTH=740>
-                <TABLE ID="Tabelle2" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%" HEIGHT=73>
+                <TABLE ID="Tabelle2" BORDER=0 CELLSPACING=17 CELLPADDING=2 WIDTH="100%" HEIGHT=73>
                     <TR>
                         <TD CLASS="News">
-                            <P><I>8 / SEP /2006</I> - <B>GAMETOOLS</B> at <A HREF="http://www.cg.tuwien.ac.at/events/EG06/index.php">Eurographics 2006</A> in Vienna</P>
-                            <P><B>Tutorial T4</B> - <A HREF="http://www.cgg.cvut.cz/~havran/eg2006tut/"><I>Efficient Sorting and Searching in Rendering Algorithms</I></A>, presented examples from the <B>GTP</B>. <A HREF="http://www.gametools.org/archives/publications/tut4eg06.pdf">Here you can find the slides presented</A>. Next follows the abstract:</P>
-                            <BLOCKQUOTE>In the proposed tutorial we would like to highlight the connection between rendering algorithms and sorting and searching as classical problems studied in computer science. We will provide both theoretical and empirical evidence that for many rendering techniques most time is spent by sorting and searching. In particular we will discuss problems and solutions for visibility computation, density estimation, and importance sampling. For each problem we mention its specific issues such as dimensionality of the search domain or online versus offline searching. We will present the underlying data structures and their enhancements in the context of specific rendering algorithms such as ray shooting, photon mapping, and hidden surface removal.</BLOCKQUOTE>
-                            <P>Some <B>pictures</B> of the different events:</P>
-                            <P><A HREF="../game.jpg"><IMG ID="Picture2" HEIGHT=142 WIDTH=200 SRC="../assets/images/game_th.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="game_th" TITLE="game_th"></A>&nbsp;<A HREF="../tshirts.jpg"><IMG ID="Picture4" HEIGHT=125 WIDTH=200 SRC="../assets/images/tshirts_th.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="tshirts_th" TITLE="tshirts_th"></A> <A HREF="../presentation.jpg"><IMG ID="Picture5" HEIGHT=150 WIDTH=200 SRC="../assets/images/presentation_th.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="presentation_th" TITLE="presentation_th"></A></P>
-                            <P>The <B>poster</B>:</P>
-                            <P><A HREF="../EG06poster.png"><IMG ID="Picture6" HEIGHT=211 WIDTH=300 SRC="../assets/images/EG06poster_th.png" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="EG06poster_th" TITLE="EG06poster_th"></A></P>
+                            <P>
+                                <TABLE WIDTH=689 BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=LEFT NOF=TE>
+                                    <TR>
+                                        <TD>
+                                            <TABLE ID="Table12" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%" HEIGHT=166>
+                                                <TR HEIGHT=200>
+                                                    <TD VALIGN=TOP WIDTH=472>
+                                                        <P STYLE="text-align: justify;">26<I> / SEP / 2006</I> - The first <B>GAMETOOLS</B> demogame, <A HREF="../html/jungle_rumble.html"><B>Jungle Rumble</B></A>, is officially available for free <A HREF="../html/jungle_rumble.html">download</A>. It was created by VUT students Martin Knecht, Michael Schwärzler (both Design &amp; Programming) and Jakob Karaszek (Design &amp; Art) based on their own Direct3D 9 engine.<BR>Jungle Rumble showcases GameTools <I>Depth Imposters</I> and <I>Raytrace Effects </I>in a computer game; besides it's also is fun to play ;-)<I>.</I></P>
+                                                        <P STYLE="text-align: justify;"><I>GameTools demogames</I> are being developed by students of universities participating in GAMETOOLS, to present the use of selected GameTools effects in a computer game. </P>
+                                                        <P STYLE="text-align: justify;">If you are a <A HREF="../html/join_the_gtp__.html">GameTools SIG member</A>, you can find the <I>Jungle Rumble sourcecode</I> in the repository under <SPAN STYLE="font-family: 'Courier New', 'Lucida Console', Courier, Monaco, Monospace;">\GTP\trunk\App\Games\Jungle_Rumble</SPAN>.</P>
+                                                    </TD>
+                                                    <TD WIDTH=23>
+                                                        <P>&nbsp;</P>
+                                                    </TD>
+                                                    <TD VALIGN=TOP WIDTH=174>
+                                                        <P><A HREF="../html/jungle_rumble.html"><IMG ID="Picture12" HEIGHT=200 WIDTH=174 SRC="../assets/images/jungle_rumble2_rot_right_th_h200.png" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="jungle_rumble2_rot_right_th_h200" TITLE="jungle_rumble2_rot_right_th_h200"></A></P>
+                                                    </TD>
+                                                </TR>
+                                            </TABLE>
+                                        </TD>
+                                    </TR>
+                                </TABLE>
+                                <I></I></P>
                         </TD>
                     </TR>
-                </TABLE>
-            </TD>
-        </TR>
-    </TABLE>
-    <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=LY>
-        <TR VALIGN=TOP ALIGN=LEFT>
-            <TD WIDTH=15 HEIGHT=22><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=15 HEIGHT=1 BORDER=0 ALT=""></TD>
-            <TD></TD>
-        </TR>
-        <TR VALIGN=TOP ALIGN=LEFT>
-            <TD></TD>
-            <TD WIDTH=740>
-                <TABLE ID="Table3" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%" HEIGHT=73>
                     <TR>
-                        <TD WIDTH=732 CLASS="News">
-                            <P><I>8 / SEP /2006</I> - <B>GAMETOOLS</B> sponsored the <A HREF="http://www.cg.tuwien.ac.at/events/EG06/graphicsmeetsgames.php"><B><I>Graphics meets Games</I></B></A> competition at <A HREF="http://www.cg.tuwien.ac.at/events/EG06/index.php">Eurographics 2006</A> in Vienna.</P>
+                        <TD CLASS="News">
+                            <P><I>6 / SEP / 2006</I> - <B>GAMETOOLS</B> had its own stand at <A HREF="http://www.cg.tuwien.ac.at/events/EG06/index.php">Eurographics 2006</A> in Vienna, where GTP technology was demonstrated to an interested audience by the GTP Community Manager, Markus Giegl together with GTP volunteers Johannes Scharl and Matthias Maschek:</P>
+                            <P>
+                                <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
+                                    <TR>
+                                        <TD ALIGN="CENTER">
+                                            <TABLE ID="Table10" BORDER=0 CELLSPACING=2 CELLPADDING=2>
+                                                <TR HEIGHT=150>
+                                                    <TD WIDTH=210>
+                                                        <P><A HREF="../game.jpg" target="_blank"><IMG ID="Picture2" HEIGHT=150 WIDTH=210 SRC="../assets/images/game_th.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="game_th" TITLE="game_th"></A></P>
+                                                    </TD>
+                                                    <TD WIDTH=213>
+                                                        <P><A HREF="../EG06poster.png" target="_blank"><IMG ID="Picture4" HEIGHT=150 WIDTH=213 SRC="../assets/images/EG06poster_th.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="EG06poster_th" TITLE="EG06poster_th"></A></P>
+                                                    </TD>
+                                                    <TD WIDTH=240>
+                                                        <P><A HREF="../tshirts.jpg" target="_blank"><IMG ID="Picture5" HEIGHT=150 WIDTH=240 SRC="../assets/images/tshirts_th.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="tshirts_th" TITLE="tshirts_th"></A></P>
+                                                    </TD>
+                                                </TR>
+                                            </TABLE>
+                                        </TD>
+                                    </TR>
+                                </TABLE>
+                            </P>
+                            <P><B>Tutorial T4 @ EG06 </B>- <A HREF="http://www.cgg.cvut.cz/~havran/eg2006tut/"><I>Efficient Sorting and Searching in Rendering Algorithms</I></A>, presented <B>GTP</B> research &amp;&nbsp; <B>GTP technology</B> <A HREF="http://www.gametools.org/archives/publications/tut4eg06.pdf">(click here to download the PDF)</A>:</P>
+                            <BLOCKQUOTE><SPAN STYLE="font-size: 9pt;">The tutorial highlights the connection between rendering algorithms and sorting and searching as classical problems studied in computer science. Both theoretical and empirical evidence that for many rendering techniques most time is spent by sorting and searching is provided. In particular we will discuss problems and solutions for visibility computation, density estimation, and importance sampling. For each problem we mention its specific issues such as dimensionality of the search domain or online versus offline searching. We will present the underlying data structures and their enhancements in the context of specific rendering algorithms such as ray shooting, photon mapping, and hidden surface removal.</SPAN></BLOCKQUOTE>
+                            <P><SPAN STYLE="font-size: 9pt;"></SPAN>&nbsp;</P>
+                        </TD>
+                    </TR>
+                    <TR>
+                        <TD CLASS="News">
+                            <P>
+                                <TABLE WIDTH=682 BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=LEFT NOF=TE>
+                                    <TR>
+                                        <TD>
+                                            <TABLE ID="Table13" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%" HEIGHT=210>
+                                                <TR HEIGHT=202>
+                                                    <TD VALIGN=TOP ALIGN=CENTER WIDTH=364>
+                                                        <P STYLE="text-align: left;"><I>4 / SEP / 2006</I> - <B>EG06</B> - <B>GAMETOOLS</B> sponsors the Graphics meets Games competition - the GTP logo is always on display - for example on the offical voting sheet, found in every Eurographics attendant's bag.</P>
+                                                    </TD>
+                                                    <TD ALIGN=RIGHT WIDTH=304>
+                                                        <P><A HREF="http://www.cg.tuwien.ac.at/events/EG06/graphicsmeetsgames.php" target="_blank"><IMG ID="Picture13" HEIGHT=200 WIDTH=283 SRC="../assets/images/eg06_voting_sheet_h200.png" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=1 STYLE="border-left-color:  rgb(0,0,0); border-left-style: solid; border-top-color:  rgb(0,0,0); border-top-style: solid; border-right-color:  rgb(0,0,0); border-right-style: solid; border-bottom-color:  rgb(0,0,0); border-bottom-style: solid;" ALT="eg06_voting_sheet_h200" TITLE="eg06_voting_sheet_h200"></A></P>
+                                                    </TD>
+                                                </TR>
+                                            </TABLE>
+                                        </TD>
+                                    </TR>
+                                </TABLE>
+                            </P>
+                        </TD>
+                    </TR>
+                    <TR>
+                        <TD CLASS="News">
+                            <P><I>22 / AUG / 2006</I> - GTP Visibility Workpackage leader Michael Wimmer presents the <B>GAMETOOLS</B> project at <A HREF="http://www.gcdc.de/">GCDC in Leipzig</A>, the biggest event for game developers in Europe, in a panel discussion about collaboration between academia and industry.</P>
+                            <P>
+                                <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
+                                    <TR>
+                                        <TD ALIGN="CENTER">
+                                            <TABLE ID="Table3" BORDER=0 CELLSPACING=2 CELLPADDING=2>
+                                                <TR HEIGHT=85>
+                                                    <TD WIDTH=131>
+                                                        <P>
+                                                            <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
+                                                                <TR>
+                                                                    <TD ALIGN="CENTER"><IMG ID="Picture9" HEIGHT=85 WIDTH=124 SRC="../assets/images/gcdc_logo2.gif" BORDER=0 ALT="gcdc_logo2" TITLE="gcdc_logo2"></TD>
+                                                                </TR>
+                                                            </TABLE>
+                                                        </P>
+                                                    </TD>
+                                                    <TD WIDTH=11>
+                                                        <P>&nbsp;</P>
+                                                    </TD>
+                                                    <TD WIDTH=85>
+                                                        <P>
+                                                            <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
+                                                                <TR>
+                                                                    <TD ALIGN="CENTER"><IMG ID="Picture10" HEIGHT=85 WIDTH=85 SRC="../assets/images/ice_blue_cube_h85.png" BORDER=0 ALT="ice_blue_cube_h85" TITLE="ice_blue_cube_h85"></TD>
+                                                                </TR>
+                                                            </TABLE>
+                                                        </P>
+                                                    </TD>
+                                                </TR>
+                                            </TABLE>
+                                        </TD>
+                                    </TR>
+                                </TABLE>
+                            </P>
+                        </TD>
+                    </TR>
+                    <TR>
+                        <TD CLASS="News">
+                            <P><I>14 / JUN / 2006</I> - <B>GAMETOOLS</B> together with <A HREF="http://developer.nvidia.com" target="_blank">NVidia</A>, sponsors the <A HREF="http://www.cg.tuwien.ac.at/events/EG06/graphicsmeetsgames.php"><B><I>Graphics meets Games</I></B></A> competition, to be held at <A HREF="http://www.cg.tuwien.ac.at/events/EG06/index.php">Eurographics 2006</A> in Vienna.</P>
                             <P>
                                 <TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=TE>
@@ -63,19 +155,14 @@
         </TR>
     </TABLE>
-    <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=LY>
+    <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=742 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
-            <TD WIDTH=17 HEIGHT=26><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=17 HEIGHT=1 BORDER=0 ALT=""></TD>
-            <TD></TD>
+            <TD WIDTH=24 HEIGHT=2><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0 ALT=""></TD>
+            <TD WIDTH=718><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=718 HEIGHT=1 BORDER=0 ALT=""></TD>
         </TR>
         <TR VALIGN=TOP ALIGN=LEFT>
             <TD></TD>
-            <TD WIDTH=740>
-                <TABLE ID="Table4" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%" HEIGHT=73>
-                    <TR>
-                        <TD CLASS="News">
-                            <P><I>22 / AUG /2006</I> - Dr. Michael Wimmer presented the <B>GAMETOOLS</B> project at <A HREF="http://www.gcdc.de/">GCDC in Leipzig</A>, the biggest event for game developers in Europe, in a panel discussion that had collaboration between academia and industry as a topic.</P>
-                        </TD>
-                    </TR>
-                </TABLE>
+            <TD WIDTH=718 CLASS="TextObject">
+                <P>&nbsp;</P>
+                <P>&nbsp;</P>
             </TD>
         </TR>